#ifndef KRY_AUDIO_OPENAL_BUFFER_H
#define KRY_AUDIO_OPENAL_BUFFER_H

#include <vector>

namespace kry
{
	namespace Audio
	{
		enum class Format : char
		{
			MONO_8 = 0,
			MONO_16,
			STEREO_8,
			STEREO_16,
			QUAD_16,
			CHANNEL_51_16,
			CHANNEL_61_16,
			CHANNEL_71_16,
			UNKNOWN = -1
		};

		class Buffer /** #TODO(incomplete) add copy/move constructors/operators */
		{
			public:
				Buffer();
				Buffer(const std::vector<unsigned char>& samples, Format format, unsigned frequency);
				Buffer(const unsigned char* samples, unsigned size, Format format, unsigned frequency);
				~Buffer();
				void resetData(const std::vector<unsigned char>& samples, Format format, unsigned frequency);

				inline unsigned getID() const;

			private:
				int formatToALFormat(Format format);

				unsigned id;
		};


		unsigned Buffer::getID() const
		{
			return id;
		}
	}
}

#endif
