#ifndef KRY_AUDIO_OPENAL_DEVICECONTEXT_H
#define KRY_AUDIO_OPENAL_DEVICECONTEXT_H

#include "Utilities\String.h"
#include <memory>

struct ALCdevice_struct;
struct ALCcontext_struct;

namespace kry
{
	namespace Audio
	{
		typedef ALCdevice_struct ALDevice;
		typedef ALCcontext_struct ALContext;

		class DeviceContext
		{
			public:
				~DeviceContext();
				inline const ALDevice* getDevice() const;
				inline const ALContext* getContext() const;

				static const DeviceContext& createDeviceContext(const Util::String& devicename = Util::String());

			private:
				DeviceContext(const Util::String& devicename);
				DeviceContext(const DeviceContext& device);
				DeviceContext& operator=(const DeviceContext& device);

				ALDevice* device;
				ALContext* context;

				static std::unique_ptr<DeviceContext> single;
		};


		const ALDevice* DeviceContext::getDevice() const
		{
			return device;
		}

		const ALContext* DeviceContext::getContext() const
		{
			return context;
		}
	}
}

#endif
