#ifndef KRY_AUDIO_OPENAL_LISTENER_H
#define KRY_AUDIO_OPENAL_LISTENER_H

#include "Utilities\Vector.h"
#include <memory>

namespace kry
{
	namespace Audio
	{
		class Listener
		{
			public:
				void setVolume(float newvolume);
				void setPosition(const Util::Vector3f& newposition);
				void setVelocity(const Util::Vector3f& newvelocity);
				void setDirection(const Util::Vector3f& newdirection);
				void setUpVector(const Util::Vector3f& newup);

				inline float getVolume() const;
				inline const Util::Vector3f& getPosition() const;
				inline const Util::Vector3f& getVelocity() const;
				inline const Util::Vector3f& getDirection() const;
				inline const Util::Vector3f& getUpVector() const;

				static Listener& createListener();

			private:
				Listener();
				Listener(const Listener& device);
				Listener& operator=(const Listener& device);

				float volume;
				Util::Vector3f position;
				Util::Vector3f velocity;
				Util::Vector3f direction;
				Util::Vector3f up;

				static std::unique_ptr<Listener> single;
		};


		float Listener::getVolume() const
		{
			return volume;
		}

		const Util::Vector3f& Listener::getPosition() const
		{
			return position;
		}

		const Util::Vector3f& Listener::getVelocity() const
		{
			return velocity;
		}

		const Util::Vector3f& Listener::getDirection() const
		{
			return direction;
		}

		const Util::Vector3f& Listener::getUpVector() const
		{
			return up;
		}
	}
}

#endif
