#ifndef KRY_GRAPHICS_FONT_H
#define KRY_GRAPHICS_FONT_H

#include "Utilities\StringTypes.h"
#include "Process\Mutex.h"
#include <ft2build.h>
#include FT_FREETYPE_H
#include "FT2Errors.h"
#include <vector>
#include <map>

namespace kry
{
	namespace Graphics
	{
		class Texture;

		class Font
		{
		public:
			Font();
			~Font();

			void loadFontFile(const Util::String& Filepath, const unsigned int FontSize, const bool MipMap = true);
			void loadFontData(const std::vector<unsigned char>& TrueType, const unsigned int FontSize, const bool MipMap = true);
			Texture& getGlyph(const char Glyph);
			FT_Glyph_Metrics getMetric(const char Glyph);

		private:
			void init();
			void process(const bool MipMap);

			static FT_Library library;
			static Process::Mutex libraryMutex;

			FT_Face face;
			std::map<char, Texture> textures;
			std::map<char, FT_Glyph_Metrics> metrics;
			Process::Mutex mutex;
		};
	}
}

#endif