#ifndef KRY_GRAPHICS_PRIMITIVES_H
#define KRY_GRAPHICS_PRIMITIVES_H

#include "Utilities\String.h"
#include "Utilities\Vector.h"

namespace kry
{
	namespace Graphics
	{
		class Texture;
		class Font;

		struct Sprite
		{
			Texture* texture = 0;
			Util::Vector2f position;
			Util::Vector2f dimensions;
			Util::Vector2f scale = Util::Vector2f(1);
			Util::Vector4f rgba = Util::Vector4f(1);
			Util::Vector2f uv[4];
			float rotation = 0;
			bool linearFilter = true;

			Sprite()
			{
				uv[0] = Util::Vector2f(0, 0);
				uv[1] = Util::Vector2f(0, 1);
				uv[2] = Util::Vector2f(1, 1);
				uv[3] = Util::Vector2f(1, 0);
			}
		};

		struct Text
		{
			Font* face = 0;
			Util::String text;
			Util::Vector2f position;
			Util::Vector2f dimensions;
			Util::Vector2f scale = Util::Vector2f(1);
			Util::Vector4f rgba = Util::Vector4f(1);
			float rotation = 0;
		};

		struct Quad
		{
			Util::Vector2f position;
			Util::Vector2f dimensions;
			Util::Vector2f scale = Util::Vector2f(1);
			Util::Vector4f rgba = Util::Vector4f(1);
			float rotation = 0;
			float thickness = 0;
		};

		struct Line
		{
			Util::Vector2f points[2];
			Util::Vector2f scale = Util::Vector2f(1);
			Util::Vector4f rgba = Util::Vector4f(1);
			float rotation = 0;
			float thickness = 1;
		};

		struct Triangle
		{
			Util::Vector2f points[3];
			Util::Vector2f scale = Util::Vector2f(1);
			Util::Vector4f rgba = Util::Vector4f(1);
			float rotation = 0;
			float thickness = 0;
		};

		struct Ellipse
		{
			Util::Vector2f radius;
			Util::Vector2f position;
			Util::Vector2f scale = Util::Vector2f(1);
			Util::Vector4f rgba = Util::Vector4f(1);
			float rotation = 0;
			float thickness = 0;
			unsigned int segments = 32;
		};
	}
}

#endif