#ifndef KRY_GRAPHICS_RENDERER_H
#define KRY_GRAPHICS_RENDERER_H

#include "Utilities\Vector.h"
#include "System\WindowTypes.h"
#include <vector>

namespace kry
{

	namespace Graphics
	{
		class Canvas;
		struct Sprite;
		struct Text;
		struct Quad;
		struct Line;
		struct Triangle;
		struct Ellipse;

		class Renderer
		{
		public:
			Renderer();
			~Renderer();

			void clear();
			void clearBuffer(const Util::Vector4f& RGBA);
			void render(System::DeviceContext DeviceContext, System::GLContext GLContext, const Util::Vector2i& RenderDimensions);
			void addCanvas(Canvas* canvas);

		private:
			void renderSprite(Sprite* sprite);
			void renderText(Text* text, Canvas* canvas);
			void renderQuad(Quad* quad);
			void renderLine(Line* line);
			void renderTriangle(Triangle* triangle);
			void renderEllipse(Ellipse* ellipse);

			std::vector<Canvas*> batch;
		};
	}
}

#endif