#ifndef KRY_GRAPHICS_TEXTURE_H
#define KRY_GRAPHICS_TEXTURE_H

#include <vector>
#include "Utilities\Vector.h"

namespace kry
{
	namespace Graphics
	{
		class Texture
		{
		public:
			Texture();
			~Texture();
			Texture(const Texture& From);
			Texture& operator=(const Texture& From);

			void loadRGBA(std::vector<unsigned char>& RGBA, const Util::Vector2i& Dimensions, const bool MipMap = true);
			void loadRGB(std::vector<unsigned char>& RGB, const Util::Vector2i& Dimensions, const bool MipMap = true);
			unsigned int getID() const;
			Util::Vector2i getDimensions() const;

		protected:
			friend class Font;
			friend class Renderer;

			void free();

			unsigned int textureID;
			Util::Vector2i dimensions;
			bool isMipMapped;
			unsigned int* life;
		};
	}
}

#endif