#ifndef KRY_MEDIA_AUDIOFACTORY_H
#define KRY_MEDIA_AUDIOFACTORY_H

#include "Utilities\StringTypes.h"
#include <vector>

namespace kry
{
	namespace Audio
	{
		enum class Format : char;
		class Source;
	}

	namespace Media
	{
		std::vector<unsigned char> mp3FileToPCM(const Util::String& Filepath, Audio::Format& Format, unsigned int& Frequency);
		std::vector<unsigned char> mp3DataToPCM(const std::vector<unsigned char>& Data, Audio::Format& Format, unsigned int& Frequency);
		void mp3FileStream(const Util::String& Filepath, Audio::Source& Source, const bool& Terminate = false);
		void mp3DataStream(const std::vector<unsigned char>& Data, Audio::Source& Source, const bool& Terminate = false);
	}
}

#endif