#ifndef KRY_MEDIA_CONFIGFACTORY_H
#define KRY_MEDIA_CONFIGFACTORY_H

#include "Utilities\StringTypes.h"
#include <vector>
#include <map>

namespace kry
{
	namespace Media
	{
		class Config
		{
		public:
			Config();
			Config(const Util::String& Filepath);
			Config(const std::vector<Util::String>& Lines);
			Config(const std::vector<unsigned char>& Data);
			~Config();

			void fileToConfig(const Util::String& Filepath);
			void dataToConfig(const std::vector<unsigned char>& Data);
			void linesToConfig(const std::vector<Util::String>& Lines);
			void clear();
			void removeSection(const Util::String& Section);
			std::vector<Util::String> getSectionNames() const;
			unsigned int getSectionsSize() const;
			bool sectionExists(const Util::String& Section) const;

			struct ConfigSection
			{
			public:
				void clear();
				void removeKey(const Util::String& Key);
				std::vector<Util::String> getKeyNames() const;
				unsigned int getKeysSize() const;
				bool keyExists(const Util::String& Key) const;
				Util::String& operator[](const Util::String& Key);

			private:
				std::map<Util::String, Util::String> keysValues;
			};

			ConfigSection& operator[](const Util::String& Section);

		private:
			Util::String trim(const Util::String& Dirty);

			std::map<Util::String, ConfigSection> config;
		};
	}
}

#endif