#ifndef KRY_MEDIA_IMAGEFACTORY_H
#define KRY_MEDIA_IMAGEFACTORY_H

#include "Utilities\StringTypes.h"
#include "Utilities\VectorTypes.h"
#include "Graphics\Texture.h"
#include <vector>

namespace kry
{
	namespace Media
	{
		Graphics::Texture imageFileToTexture(const Util::String& Filepath, const bool MipMap = true);
		Graphics::Texture imageDataToTexture(const std::vector<unsigned char>& Data, const bool MipMap = true);
		std::vector<unsigned char> imageFileToRGBA(const Util::String& Filepath, Util::Vector2i& Dimensions);
		std::vector<unsigned char> imageDataToRGBA(const std::vector<unsigned char>& Data, Util::Vector2i& Dimensions);
	}
}

#endif