#ifndef KRY_MEDIA_ZIP_H
#define KRY_MEDIA_ZIP_H

#include "Utilities\String.h"
#include <vector>
#include <map>

namespace kry
{
	namespace Media
	{
		class Zip
		{
		public:
			Zip();
			Zip(const Util::String& Filepath);
			Zip(const std::vector<unsigned char>& Data);
			~Zip();

			void clear();
			void fileToZip(const Util::String& ZipAddress);
			void dataToZip(const std::vector<unsigned char>& Data);			
			std::vector<Util::String> getDirectoryNames() const;
			bool directoryExists(const Util::String& Directory) const;
			void zipToFile(const Util::String& Filepath) const;
			std::vector<unsigned char> zipToData() const;

			struct ZipDirectory
			{
			public:
				void clear();
				std::vector<Util::String> getFileNames() const;
				bool fileExists(const Util::String& File) const;
				std::vector<unsigned char>& operator[](const Util::String& File);
			protected:
				friend class Zip;
				std::map<Util::String, std::vector<unsigned char> > files;
			};

			ZipDirectory& operator[](const Util::String& Directory);

			static std::vector<unsigned char> fileFromFileZip(const Util::String& ZipAddress, const Util::String& FilePath);
			static std::vector<unsigned char> fileFromDataZip(const std::vector<unsigned char>& Data, const Util::String& FilePath);

		private:
			std::map<Util::String, ZipDirectory> zip;
		};
	}
}

#endif