#ifndef KRY_NETWORK_DATAGRAMPACKET_H
#define KRY_NETWORK_DATAGRAMPACKET_H

#include "Network\Packet.h"

namespace kry
{
	namespace Network
	{
		class DatagramPacket : public Packet
		{
			public:
				DatagramPacket();
				DatagramPacket(unsigned size, const Util::String& address, unsigned short port);
				DatagramPacket(const DatagramPacket& packet);
				DatagramPacket(DatagramPacket&& packet);

				inline void setAddress(const Util::String& newaddress);
				inline void setPort(unsigned short newport);
				inline const Util::String& getAddress() const;
				inline unsigned short getPort() const;

				inline DatagramPacket& operator=(const DatagramPacket& packet);
				inline DatagramPacket& operator=(DatagramPacket&& packet);

			private:
				Util::String address;
				unsigned short port;
		};


		void DatagramPacket::setAddress(const Util::String& newaddress)
		{
			address = newaddress;
		}

		void DatagramPacket::setPort(unsigned short newport)
		{
			port = newport;
		}

		const Util::String& DatagramPacket::getAddress() const
		{
			return address;
		}

		unsigned short DatagramPacket::getPort() const
		{
			return port;
		}

		DatagramPacket& DatagramPacket::operator=(const DatagramPacket& packet)
		{
			address = packet.address;
			port = packet.port;
			Packet::operator=(packet);
			return *this;
		}

		DatagramPacket& DatagramPacket::operator=(DatagramPacket&& packet)
		{
			address = std::move(packet.address);
			port = packet.port;
			Packet::operator=(std::move(packet));
			return *this;
		}
	}
}

#endif
