#ifndef KRY_PROCESS_THREAD_H
#define KRY_PROCESS_THREAD_H

#include <functional>

namespace kry
{
	namespace Process
	{
		class Thread
		{
		public:
			Thread();
			Thread(const std::function<void()> Procedure);
			Thread(const Thread& From);
			Thread& operator=(const Thread& From);
			virtual ~Thread();

			void join();
			void pause();
			void resume();
			void realtime();
			void close();
			bool running() const;

		private:
			static unsigned int __stdcall entry(void*);

			void* handle;
			std::function<void()> procedure;
			unsigned int id;
		};
	}
}

#endif