#ifndef KRY_SYSTEM_INPUT_H
#define KRY_SYSTEM_INPUT_H

namespace kry
{
	namespace System
	{
		enum class Button : char
		{
			LEFT = 0,
			MIDDLE,
			RIGHT,
			X1,
			X2,
			UNKNOWN = -1
		};

		enum class Key : short
		{
			A = 0,
			B,
			C,
			D,
			E,
			F,
			G,
			H,
			I,
			J,
			K,
			L,
			M,
			N,
			O,
			P,
			Q,
			R,
			S,
			T,
			U,
			V,
			W,
			X,
			Y,
			Z,
			NUMBER_0,
			NUMBER_1,
			NUMBER_2,
			NUMBER_3,
			NUMBER_4,
			NUMBER_5,
			NUMBER_6,
			NUMBER_7,
			NUMBER_8,
			NUMBER_9,
			NUMPAD_0,
			NUMPAD_1,
			NUMPAD_2,
			NUMPAD_3,
			NUMPAD_4,
			NUMPAD_5,
			NUMPAD_6,
			NUMPAD_7,
			NUMPAD_8,
			NUMPAD_9,
			NUMLOCK,
			ADD,			// numpad +
			SUBSTRACT,		// numpad -
			MULTIPLY,		// numpad *
			DIVIDE,			// numpad /
			DECIMAL,		// numpad .
			COMMA,			// ,
			PERIOD,			// .
			SLASH_FORWARD,	// /
			SLASH_BACKWARD,	// backslash
			SEMICOLON,		// ;
			QUOTE,			//
			BRACKET_LEFT,	// [
			BRACKET_RIGHT,	// ]
			TILDE,			// ~
			DASH,			// -
			EQUALS,			// =
			UP,
			DOWN,
			LEFT,
			RIGHT,
			INSERT,
#if defined(DELETE)
	#define DELETE_PUSHED
	#pragma push_macro("DELETE")
	#undef DELETE
#endif
			DELETE,
#if defined(DELETE_PUSHED)
	#undef DELETE_PUSHED
	#pragma pop_macro("DELETE")
#endif
			HOME,
			END,
			PAGE_UP,
			PAGE_DOWN,
			BACKSPACE,
			SPACE,
			ESCAPE,
			RETURN,
			PRINT_SCREEN,
			SCROLL_LOCK,
			PAUSE,
			TAB,
			CAPS_LOCK,
			CONTROL_R,
			CONTROL_L,
			SHIFT_R,
			SHIFT_L,
			ALT_R,
			ALT_L,
			SYSTEM_L,
			SYSTEM_R,
			MENU,
			F1,
			F2,
			F3,
			F4,
			F5,
			F6,
			F7,
			F8,
			F9,
			F10,
			F11,
			F12,
			F13,
			F14,
			F15,
			UNKNOWN = -1
		};
	}
}

#endif
