#ifndef KRY_SYSTEM_WINDOWEVENT_H
#define KRY_SYSTEM_WINDOWEVENT_H

#include "System\Input.h"
#include "Utilities\Vector.h"

namespace kry
{
	namespace System
	{
		enum class EventType
		{
			MOUSE,
			MOUSE_WHEEL,
			KEY,
			MOVE,
			SIZE,
			FOCUS,
			CLOSE,
			NONE
		};

		struct WindowEvent /** #TODO(refactor) if VS releases unrestricted unions, all of this can go in one union */
		{
			EventType type;
			Util::Vector2i position;
			Util::Vector2i size;
			Button button;
			Key key;
			int wheelvalue;
			union
			{
				bool down;
				bool moving;
				bool resizing;
				bool focused;
				bool open;
			};
		};

		/*
		class WindowEvent
		{
			public:
				EventType type;
				virtual ~WindowEvent() {}
		};

		struct MouseEvent : public WindowEvent
		{
			Util::Vector2i position;
			Button button;
			bool down;
		};

		struct MouseWheelEvent : public WindowEvent
		{
			Util::Vector2i position;
			int value;
		};

		struct KeyEvent : public WindowEvent
		{
			Key key;
			bool down;
		};

		struct MoveEvent : public WindowEvent
		{
			Util::Vector2i position;
			bool moving;
		};

		struct SizeEvent : public WindowEvent
		{
			Util::Vector2i size;
			bool resizing;
		};

		struct FocusEvent : public WindowEvent
		{
			bool focused;
		};

		struct CloseEvent : public WindowEvent
		{
			bool open;
		};*/
	}
}

#endif
