#ifndef KRY_UTILITIES_EXCEPTION_H
#define KRY_UTILITIES_EXCEPTION_H

#include "Utilities\StringTypes.h"
#include <exception>
#include <memory>

#ifdef __MINGW32__
	#define __FUNCSIG__ __PRETTY_FUNCTION__
#endif
#define KRY_EXCEPTION_DATA kry::Util::String(__FILE__), kry::Util::String(__FUNCSIG__), static_cast<unsigned>(__LINE__)

namespace kry
{
	namespace Util
	{
		class Exception : public std::exception
		{
			public:
				Exception(const String& file, const String& function, unsigned line);
				Exception(const String& message, const String& file, const String& function, unsigned line);
				Exception(const Exception& copy);
				virtual ~Exception();
				
				virtual const char* what() const throw();
				Exception& operator=(const Exception& copy);

				inline const String& getMessage() const;

			private:
				Exception();
				std::unique_ptr<String> message;
		};


		const String& Exception::getMessage() const
		{
			return *message;
		}
	}
}

#endif
