#include "Audio\Listener.h"
#include "OpenAL\al.h"

namespace kry
{
	namespace Audio
	{
		std::unique_ptr<Listener> Listener::single(nullptr);

		void Listener::setVolume(float newvolume)
		{
			volume = newvolume;
			alListenerf(AL_GAIN, volume);
		}

		void Listener::setPosition(const Util::Vector3f& newposition)
		{
			position = newposition;
			alListener3f(AL_POSITION, position[0], position[1], position[2]);
		}

		void Listener::setVelocity(const Util::Vector3f& newvelocity)
		{
			velocity = newvelocity;
			alListener3f(AL_VELOCITY, velocity[0], velocity[1], velocity[2]);
		}

		void Listener::setDirection(const Util::Vector3f& newdirection)
		{
			direction = newdirection;
			Util::Vector<float, 6> dir;
			dir[0] = direction[0];
			dir[1] = direction[1];
			dir[2] = direction[2];
			dir[3] = up[0];
			dir[4] = up[1];
			dir[5] = up[2];

			alListenerfv(AL_ORIENTATION, dir.elem);
		}

		void Listener::setUpVector(const Util::Vector3f& newup)
		{
			up = newup;
			Util::Vector<float, 6> dir;
			dir[0] = direction[0];
			dir[1] = direction[1];
			dir[2] = direction[2];
			dir[3] = up[0];
			dir[4] = up[1];
			dir[5] = up[2];

			alListenerfv(AL_ORIENTATION, dir.elem);
		}

		Listener& Listener::createListener()
		{
			if (!single)
				single.reset(new Listener);
			return *single;
		}

		Listener::Listener()
		{
			up[0] = 0.0f;
			up[1] = 1.0f;
			up[2] = 0.0f;

			setUpVector(up);
		}

		Listener::Listener(const Listener& device)
		{
		}

		Listener& Listener::operator=(const Listener& device)
		{
			return *this;
		}
	}
}
