#include "Network\DatagramPacket.h"

namespace kry
{
	namespace Network
	{
		DatagramPacket::DatagramPacket() : Packet(), port(0)
		{
		}

		DatagramPacket::DatagramPacket(unsigned size, const Util::String& address, unsigned short port) : Packet(size), address(address), port(port)
		{
		}

		DatagramPacket::DatagramPacket(const DatagramPacket& packet) : Packet(packet), address(packet.address), port(packet.port)
		{
		}

		DatagramPacket::DatagramPacket(DatagramPacket&& packet) : Packet(std::move(packet)), address(std::move(packet.address)), port(packet.port)
		{
		}
	}
}
