#include "Network\Packet.h"

namespace kry
{
	namespace Network
	{
		Packet::Packet() : data(headersize), itr(4)
		{
			data.resize(headersize);
			updateHeader(data.size());
		}

		Packet::Packet(unsigned size) : data(headersize + size), itr(4)
		{
			data.resize(headersize + size);
			updateHeader(data.size());
		}

		Packet::Packet(const Packet& packet) : data(packet.data), itr(packet.itr)
		{
			updateHeader(data.size());
		}

		Packet::Packet(Packet&& packet) : data(std::move(packet.data)), itr(packet.itr)
		{
			updateHeader(data.size());
		}

		Packet::~Packet()
		{
		}
	}
}
