#include "Utilities\Exception.h"
#include "Utilities\BasicString.h"

namespace kry
{
	namespace Util
	{
		Exception::Exception(const String& file, const String& function, unsigned line) : 
			message(new String("Exception: \n[File=" + file + "]\n[Function=" + function + 
			"]\n[Line=" + toString(line) + "]\n"))
		{
		}

		Exception::Exception(const String& message, const String& file, const String& function, unsigned line) : 
			message(new String(message + "\n[File=" + file + 
			"]\n[Function=" + function + "]\n[Line=" + toString(line) + "]\n"))
		{
		}

		Exception::Exception(const Exception& copy) : message(new String(*copy.message.get()))
		{
		}

		Exception::~Exception()
		{
		}

		const char* Exception::what() const throw()
		{
			return message->getData();
		}

		Exception& Exception::operator=(const Exception& copy)
		{
			*message = *copy.message;
			return *this;
		}
		
		Exception::Exception() : message(new String(stringLiteral("Exception: \n[File=]\n[Function=]\n[Line=]\n")))
		{
		}
	}
}
