#include "Utilities\Logger.h"
#include "Utilities\StringConvert.h"
#include "Utilities\Exception.h"
#include <iostream>
#include <ctime>

namespace kry
{
	namespace Util
	{
		std::ostream* Logger::output(&std::cout);

		void Logger::setOutputStream(std::ostream& stream)
		{
			output = &stream;
		}

		void Logger::log(const String& message)
		{
			*output << message;
		}

		void Logger::log(const Exception& exception)
		{
			*output << exception.getMessage();
		}

		String Logger::getDateTime()
		{
			time_t t;
			time(&t);

			struct tm now;
			localtime_s(&now, &t);

			return toString(now.tm_year + 1900) + '\\' + toString(now.tm_mon + 1) + '\\' + toString(now.tm_mday) + '-' + 
				toString(now.tm_hour) + ':' + toString(now.tm_min) + ':' + toString(now.tm_sec) + 
				(now.tm_hour >= 12 ? stringLiteral("pm") : stringLiteral("am"));
		}
	}
}
