#include "Utilities\Random.h"
#include "Utilities\BasicString.h"
#include <string>

namespace kry
{
	namespace Util
	{
		Random::Random()
		{
			engine.seed(314159265);
		}

		Random::Random(unsigned long Seed)
		{
			engine.seed(Seed);
		}

		Random::Random(String Seed)
		{
			std::string buf(Seed.getData(), Seed.getLength());
			std::seed_seq seed(buf.begin(), buf.end());
			engine.seed(seed);
		}

		void Random::reSeed(unsigned long Seed)
		{
			engine.seed(Seed);
		}

		void Random::reSeed(const String& Seed)
		{
			std::string buf(Seed.getData(), Seed.getLength());
			std::seed_seq seed(buf.begin(), buf.end());
			engine.seed(seed);
		}

		int Random::randomInt(int Min, int Max)
		{
			std::uniform_int_distribution<int> distribution(Min, Max);

			return distribution(engine);
		}

		float Random::randomFloat(float Min, float Max)
		{
			std::uniform_real_distribution<float> distribution(Min, Max);

			return distribution(engine);
		}

		String Random::randomString(unsigned Size, int Min, int Max)
		{
			String string(Size, 0);

			for (unsigned i = 0; i < Size; ++i)
				string[i] = static_cast<char>(randomInt(Min, Max));

			return string;
		}
	}
}
