#include "Media\ConfigFactory.h"
#include "Utilities\String.h"
#include <iostream>
#include <fstream>
#include <string>

using namespace std;
using namespace kry;
using namespace Media;
using namespace Util;

void pause()
{
	std::cout << "\nPress any key to continue . . .";
	std::cin.get();
}

int endWithError(char* msg, int error = 0)
{
	cout << msg << "\n";
	pause();
	return error;
}

int main(int argc, char* argv[])
{
	try
	{
		Config config;
		config["testSection"]["testKey"] = "testValue";

		std::cout << config["testSection"]["testKey"] << "\n";

		config.fileToConfig("config.txt");

		std::cout << "\nSections: \n";
		auto sections = config.getSectionNames();
		for (auto& section : sections)
		{
			std::cout << "[" << section << "]\n";
			auto keys = config[section].getKeyNames();

			for (auto& key : keys)
			{
				std::cout << "\t[" << key << "] = [" << config[section][key] << "]\n";
			}
		}
		std::cout << "\n";
	}
	catch (const Exception& e)
	{
		std::cout << e.what() << std::endl;
	}

	pause();
}
