#include "Audio\DeviceContext.h"
#include "Audio\Buffer.h"
#include "Audio\Listener.h"
#include "Audio\Source.h"
#include "Utilities\String.h"
#include "Media\AudioFactory.h"
#include <iostream>
#include <fstream>
#include <string>
#include <Windows.h>

using namespace std;
using namespace kry;
using namespace Audio;
using namespace Util;

void pause()
{
	std::cout << "\nPress any key to continue . . .";
	std::cin.get();
}

std::vector<unsigned char> loadFileBinary(const char* Filepath)
{
	FILE *fp = 0;
	fopen_s(&fp, Filepath, "rb");

	if (!fp) 
		throw Util::Exception(Util::stringLiteral("Could not open file!\n"), KRY_EXCEPTION_DATA);

	fseek(fp, 0, SEEK_END);
	long fileSize = ftell(fp);
	rewind(fp);

	std::vector<unsigned char> data(fileSize);
	data.resize(fileSize);
	fread(data.data(), sizeof(BYTE), fileSize, fp);
	fclose(fp);

	return data;
}

int main(int argc, char* argv[])
{
	try
	{
		/*Format format;
		unsigned int freq;

		// using binary function
		std::vector<unsigned char> mp3Data = loadFileBinary("music.mp3");		
		std::vector<unsigned char> pcm = Media::mp3DataToPCM(mp3Data, format, freq);*/

		// using file function
		//std::vector<unsigned char> pcm = Media::mp3FileToPCM("music.mp3", format, freq);

		/*std::cout << "PCM size = " << pcm.size() << "\n";
		std::cout << "Frequency = " << freq << "\n";

		DeviceContext::createDeviceContext();
		Listener::createListener();

		Buffer musicbuf(pcm, format, freq);
		Source music1(musicbuf);
		music1.play();*/

		DeviceContext::createDeviceContext();
		Listener::createListener();

		Source music1;
		Media::mp3FileStream("music.mp3", music1);

		pause();
	}
	catch (const Exception& e)
	{
		std::cout << e.what() << std::endl;
	}

	pause();
}
