#include <iostream>
#include <Network\NetworkDevice.h>
#include <Network\Packet.h>
#include <Network\TCPSocket.h>
// requires a link to Ws2_32.lib

using namespace kry;
using namespace Network;

void pause()
{
	std::cout << "\nPress any key to continue...\n";
	std::cin.get();
}

int main()
{
	TCPSocket* socket = nullptr;
	try
	{
		NetworkDevice::getDevice()->startNetworking();

		/** #TODO(test) test all Socket/Server types */
		std::cout << "Starting\n";
		socket = new TCPSocket("kryptagame.com", 3000);
		socket->setRecvTimeout(5000);
		std::cout << "Connecting\n";
		socket->connect();
		if (!socket->isConnected())
			std::cout << "Failed to connect\n";
		std::cout << "Sending\n";
		char string[] = "GET / HTTP/1.1\r\n\r\n";
		auto len = sizeof(string);
		socket->sendRaw(string, len);
		std::cout << "Sent\n";

		//Packet packet;
		std::cout << "Receiving\n";
		char data[1000]{0};
		if (!socket->receiveRaw(data, 1000))
			std::cout << "Nothing\n";
		else
			std::cout << "Received\n";

		for (unsigned i = 0; i < 1000; ++i)
			if (data[i] != 0)
				std::cout << data[i];
		std::cout << std::endl;
	}
	catch (const Util::Exception& e)
	{
		std::cout << e.what() << std::endl;
	}
	
	delete socket;
	NetworkDevice::getDevice()->stopNetworking();

	pause();
}
