#include <iostream>
#include <Windows.h>
#include "Process\Mutex.h"
#include "Process\Thread.h"

void myThreadFunction(char* text, int times = 5, int sleep = 1000)
{
	for (int i = 0; i < times; ++i)
	{
		std::cout << text << "\n";
		Sleep(sleep);
	}
}

int main()
{
	using namespace kry;
	using namespace Process;
	using namespace std;

	std::cout << "Thread tests\n\n";

	char* threadText = "Thread 1";
	Thread* threadtest, *threadtest2;

	{ // Scope test
		threadtest = new Thread([&](){ myThreadFunction(threadText); });
		threadtest2 = new Thread([&](){ myThreadFunction("Thread 2", 10, 200); });

		Thread threadtest3([&]() { myThreadFunction("Thread 3", 10, 150); });

		threadtest3.join();
	}

	threadtest->join();
	threadtest2->join();

	std::cout << "\nThreads all joined!\n";
	std::cin.get();

	delete threadtest;
	delete threadtest2;

	return 0;
}