#include <iostream>
#include "System\Window.h"
#include "Graphics\Graphics.h"
#include "Utilities\BasicString.h"
#include "Utilities\Math.h"
#include <Windows.h>

void pause()
{
	std::cout << "\nEnd...\n";
}

int main()
{
	using namespace kry;
	using namespace Util;
	using namespace System;
	using namespace Graphics;

	try
	{
		/*LARGE_INTEGER large;

		if ( !QueryPerformanceFrequency( &large ) )
			throw Exception( "Failed to initalise performance timer!", KRY_EXCEPTION_DATA );

		double frequency = double( large.QuadPart ) / 1000.0;
		QueryPerformanceCounter( &large );
		double start = double( large.QuadPart );

		for ( int i = 0; i < 999999; ++i )
			String test = toString(float(i) + 0.123456f);

		QueryPerformanceCounter( &large );
		std::cout << "Time " << ( double( large.QuadPart - start ) / frequency ) << "\n";*/

		//return 0;

		bool running = true;
		Window window(stringLiteral("Test"), Vector2i(800, 600));
		WindowEvent event;

		Vector2i dimensions = window.getSize();

		// graphics stuff
		Renderer myRenderer;
		Canvas myCanvas;
		myRenderer.addCanvas(&myCanvas);
		Line coneLineLeft;
		Line coneLineRight;
		Line checkLine;

		myCanvas.dimensions = dimensions;
		myCanvas.setResolution(dimensions);
		myCanvas.addLine(&coneLineLeft);
		myCanvas.addLine(&coneLineRight);
		myCanvas.addLine(&checkLine);

		float coneAngle = 45;
		float coneRadius = 300;
		float coneDirection = 0;

		while (running)
		{
			while (window.getEvent(event))
			{
				myRenderer.clearBuffer(Vector4f(0, 0, 0, 1));
					
				if (event.type == EventType::CLOSE)
					running = event.open;
				else if (event.type == EventType::KEY)
				{
					if (event.key == Key::ESCAPE)
						running = false;

					if (event.key == Key::L)
						coneAngle += 0.3f;

					if (event.key == Key::K)
						coneAngle -= 0.3f;

					if (event.key == Key::O)
						coneDirection += 0.3f;

					if (event.key == Key::I)
						coneDirection -= 0.3f;
				}
				else if (event.type == EventType::SIZE)
				{
					dimensions = window.getSize();
					myCanvas.dimensions = dimensions;
					myCanvas.setResolution(dimensions);
				}
			}

			Vector2f centre = Vector2f(float(dimensions[0]) * 0.5f, float(dimensions[1]) * 0.5f);
			float coneHalf = coneAngle * 0.5f;
			float coneLeft = coneDirection - coneAngle;
			float coneRight = coneDirection + coneAngle;
			float checkAngle = pointDirection(centre, window.getCursorPos());
			
			coneLineLeft.points[0] = centre;
			coneLineLeft.points[1] = trajectory(centre, coneLeft, coneRadius);
			coneLineRight.points[0] = centre;
			coneLineRight.points[1] = trajectory(centre, coneRight, coneRadius);
			checkLine.points[0] = centre;
			checkLine.points[1] = trajectory(centre, checkAngle, coneRadius);
			checkLine.rgba = Vector4f(1, 0, 0, 1);

			if (angleInCone(checkAngle, coneLeft, coneRight))
				checkLine.rgba = Vector4f(0, 1, 0, 1);
			
			myRenderer.render(window.getContext(), window.getGLContext(), window.getSize());
		}
		window.destroy();
	}
	catch (const Exception& e)
	{
		std::cout << e.what() << std::endl;
		std::cin.get();
	}

	pause();
}
