#include <iostream>
#include "System\Window.h"
#include "Utilities\BasicString.h"
#include <Windows.h>
//#include <GL\glew.h>
#include <GL\gl.h>
#include <GL\glu.h>

void pause()
{
	std::cout << "\nPress any key to continue...\n";
	std::cin.get();
}

void assert(bool assertion, const char* functionName)
{
	std::cout << (assertion ? "[+] " : "[-] ") << functionName << '\n';
}

int main()
{
	using namespace kry;
	using namespace Util;
	using namespace System;

	try
	{
		bool running = true;
		Window window(stringLiteral("Test"), Vector2i(800, 600));
		WindowEvent event;

		Vector2i dimensions = window.getSize();

		glViewport(0, 0, dimensions[0], dimensions[1]);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		glOrtho(0.0, dimensions[0], dimensions[1], 0.0, 0.0, 1.0);
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		glClearColor(0, 0, 0.25, 1);

		while (running)
		{
			window.getEvent(event);
			{
				if (event.type == EventType::CLOSE)
					running = event.open;
				else if (event.type == EventType::KEY)
				{
					if (event.key == Key::ESCAPE)
						running = false;
				}
				else if (event.type == EventType::MOUSE)
				{
					//std::cout << event.position[0] << ", " << event.position[1] << std::endl;
				}
			}

			Vector2i& pos = window.getCursorPos();

			glClear(GL_COLOR_BUFFER_BIT);
			glColor3f(1, 0, 0);

			glBegin(GL_QUADS);
			glVertex2i(pos[0] - 5, pos[1] - 5);
			glVertex2i(pos[0] + 5, pos[1] - 5);
			glVertex2i(pos[0] + 5, pos[1] + 5);
			glVertex2i(pos[0] - 5, pos[1] + 5);
			glEnd();

			glFlush();

			SwapBuffers(window.getContext());
		}
		window.destroy();
	}
	catch (const Exception& e)
	{
		std::cout << e.what() << std::endl;
	}

	pause();
}
